=begin
#Selling Partner API for Catalog Items

#The Selling Partner API for Catalog Items helps you programmatically retrieve item details for items in the catalog.

OpenAPI spec version: v0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.24
=end

require 'spec_helper'
require 'json'

# Unit tests for AmzSpApi::CatalogItemsApiModel::CatalogApi
# Automatically generated by swagger-codegen (github.com/swagger-api/swagger-codegen)
# Please update as you see appropriate
describe 'CatalogApi' do
  before do
    # run before each test
    @instance = AmzSpApi::CatalogItemsApiModel::CatalogApi.new
  end

  after do
    # run after each test
  end

  describe 'test an instance of CatalogApi' do
    it 'should create an instance of CatalogApi' do
      expect(@instance).to be_instance_of(AmzSpApi::CatalogItemsApiModel::CatalogApi)
    end
  end

  # unit tests for get_catalog_item
  # Returns a specified item and its attributes.  **Usage Plan:**  | Rate (requests per second) | Burst | | ---- | ---- | | 1 | 1 |  For more information, see \&quot;Usage Plans and Rate Limits\&quot; in the Selling Partner API documentation.
  # @param marketplace_id A marketplace identifier. Specifies the marketplace for the item.
  # @param asin The Amazon Standard Identification Number (ASIN) of the item.
  # @param [Hash] opts the optional parameters
  # @return [GetCatalogItemResponse]
  describe 'get_catalog_item test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for list_catalog_categories
  # Returns the parent categories to which an item belongs, based on the specified ASIN or SellerSKU.  **Usage Plan:**  | Rate (requests per second) | Burst | | ---- | ---- | | 1 | 1 |  For more information, see \&quot;Usage Plans and Rate Limits\&quot; in the Selling Partner API documentation.
  # @param marketplace_id A marketplace identifier. Specifies the marketplace for the item.
  # @param [Hash] opts the optional parameters
  # @option opts [String] :asin The Amazon Standard Identification Number (ASIN) of the item.
  # @option opts [String] :seller_sku Used to identify items in the given marketplace. SellerSKU is qualified by the seller&#x27;s SellerId, which is included with every operation that you submit.
  # @return [ListCatalogCategoriesResponse]
  describe 'list_catalog_categories test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for list_catalog_items
  # Returns a list of items and their attributes, based on a search query or item identifiers that you specify. When based on a search query, provide the Query parameter and optionally, the QueryContextId parameter. When based on item identifiers, provide a single appropriate parameter based on the identifier type, and specify the associated item value. MarketplaceId is always required.  **Usage Plan:**  | Rate (requests per second) | Burst | | ---- | ---- | | 1 | 1 |  For more information, see \&quot;Usage Plans and Rate Limits\&quot; in the Selling Partner API documentation.
  # @param marketplace_id A marketplace identifier. Specifies the marketplace for which items are returned.
  # @param [Hash] opts the optional parameters
  # @option opts [String] :query Keyword(s) to use to search for items in the catalog. Example: &#x27;harry potter books&#x27;.
  # @option opts [String] :query_context_id An identifier for the context within which the given search will be performed. A marketplace might provide mechanisms for constraining a search to a subset of potential items. For example, the retail marketplace allows queries to be constrained to a specific category. The QueryContextId parameter specifies such a subset. If it is omitted, the search will be performed using the default context for the marketplace, which will typically contain the largest set of items.
  # @option opts [String] :seller_sku Used to identify an item in the given marketplace. SellerSKU is qualified by the seller&#x27;s SellerId, which is included with every operation that you submit.
  # @option opts [String] :upc A 12-digit bar code used for retail packaging.
  # @option opts [String] :ean A European article number that uniquely identifies the catalog item, manufacturer, and its attributes.
  # @option opts [String] :isbn The unique commercial book identifier used to identify books internationally.
  # @option opts [String] :jan A Japanese article number that uniquely identifies the product, manufacturer, and its attributes.
  # @return [ListCatalogItemsResponse]
  describe 'list_catalog_items test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

end
