# fba-inbound-eligibility-api-model

AmzSpApi::FbaInboundEligibilityApiModel - the Ruby gem for the Selling Partner API for FBA Inbound Eligibilty

With the FBA Inbound Eligibility API, you can build applications that let sellers get eligibility previews for items before shipping them to Amazon's fulfillment centers. With this API you can find out if an item is eligible for inbound shipment to Amazon's fulfillment centers in a specific marketplace. You can also find out if an item is eligible for using the manufacturer barcode for FBA inventory tracking. Sellers can use this information to inform their decisions about which items to ship Amazon's fulfillment centers.

This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: v1
- Package version: 0.1.0
- Build package: io.swagger.codegen.v3.generators.ruby.RubyClientCodegen
For more information, please visit [https://sellercentral.amazon.com/gp/mws/contactus.html](https://sellercentral.amazon.com/gp/mws/contactus.html)

## Installation

### Build a gem

To build the Ruby code into a gem:

```shell
gem build fba-inbound-eligibility-api-model.gemspec
```

Then either install the gem locally:

```shell
gem install ./fba-inbound-eligibility-api-model-0.1.0.gem
```
(for development, run `gem install --dev ./fba-inbound-eligibility-api-model-0.1.0.gem` to install the development dependencies)

or publish the gem to a gem hosting service, e.g. [RubyGems](https://rubygems.org/).

Finally add this to the Gemfile:

    gem 'fba-inbound-eligibility-api-model', '~> 0.1.0'

### Install from Git

If the Ruby gem is hosted at a git repository: https://github.com/GIT_USER_ID/GIT_REPO_ID, then add the following in the Gemfile:

    gem 'fba-inbound-eligibility-api-model', :git => 'https://github.com/GIT_USER_ID/GIT_REPO_ID.git'

### Include the Ruby code directly

Include the Ruby code directly using `-I` as follows:

```shell
ruby -Ilib script.rb
```

## Getting Started

Please follow the [installation](#installation) procedure and then run the following code:
```ruby
# Load the gem
require 'fba-inbound-eligibility-api-model'

api_instance = AmzSpApi::FbaInboundEligibilityApiModel::FbaInboundApi.new
asin = 'asin_example' # String | The ASIN of the item for which you want an eligibility preview.
program = 'program_example' # String | The program that you want to check eligibility against.
opts = { 
  marketplace_ids: ['marketplace_ids_example'] # Array<String> | The identifier for the marketplace in which you want to determine eligibility. Required only when program=INBOUND.
}

begin
  result = api_instance.get_item_eligibility_preview(asin, program, opts)
  p result
rescue AmzSpApi::FbaInboundEligibilityApiModel::ApiError => e
  puts "Exception when calling FbaInboundApi->get_item_eligibility_preview: #{e}"
end
```

## Documentation for API Endpoints

All URIs are relative to *https://sellingpartnerapi-na.amazon.com/*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AmzSpApi::FbaInboundEligibilityApiModel::FbaInboundApi* | [**get_item_eligibility_preview**](docs/FbaInboundApi.md#get_item_eligibility_preview) | **GET** /fba/inbound/v1/eligibility/itemPreview | 

## Documentation for Models

 - [AmzSpApi::FbaInboundEligibilityApiModel::Error](docs/Error.md)
 - [AmzSpApi::FbaInboundEligibilityApiModel::ErrorList](docs/ErrorList.md)
 - [AmzSpApi::FbaInboundEligibilityApiModel::GetItemEligibilityPreviewResponse](docs/GetItemEligibilityPreviewResponse.md)
 - [AmzSpApi::FbaInboundEligibilityApiModel::ItemEligibilityPreview](docs/ItemEligibilityPreview.md)

## Documentation for Authorization

 All endpoints do not require authorization.

