=begin
#Selling Partner API for Finances

#The Selling Partner API for Finances helps you obtain financial information relevant to a seller's business. You can obtain financial events for a given order, financial event group, or date range without having to wait until a statement period closes. You can also obtain financial event groups for a given date range.

OpenAPI spec version: v0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.24
=end

require 'date'

module AmzSpApi::FinancesApiModel
  # Contains all information related to a financial event.
  class FinancialEvents
    attr_accessor :shipment_event_list

    attr_accessor :refund_event_list

    attr_accessor :guarantee_claim_event_list

    attr_accessor :chargeback_event_list

    attr_accessor :pay_with_amazon_event_list

    attr_accessor :service_provider_credit_event_list

    attr_accessor :retrocharge_event_list

    attr_accessor :rental_transaction_event_list

    attr_accessor :product_ads_payment_event_list

    attr_accessor :service_fee_event_list

    attr_accessor :seller_deal_payment_event_list

    attr_accessor :debt_recovery_event_list

    attr_accessor :loan_servicing_event_list

    attr_accessor :adjustment_event_list

    attr_accessor :safet_reimbursement_event_list

    attr_accessor :seller_review_enrollment_payment_event_list

    attr_accessor :fba_liquidation_event_list

    attr_accessor :coupon_payment_event_list

    attr_accessor :imaging_services_fee_event_list

    attr_accessor :network_commingling_transaction_event_list

    attr_accessor :affordability_expense_event_list

    attr_accessor :affordability_expense_reversal_event_list

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'shipment_event_list' => :'ShipmentEventList',
        :'refund_event_list' => :'RefundEventList',
        :'guarantee_claim_event_list' => :'GuaranteeClaimEventList',
        :'chargeback_event_list' => :'ChargebackEventList',
        :'pay_with_amazon_event_list' => :'PayWithAmazonEventList',
        :'service_provider_credit_event_list' => :'ServiceProviderCreditEventList',
        :'retrocharge_event_list' => :'RetrochargeEventList',
        :'rental_transaction_event_list' => :'RentalTransactionEventList',
        :'product_ads_payment_event_list' => :'ProductAdsPaymentEventList',
        :'service_fee_event_list' => :'ServiceFeeEventList',
        :'seller_deal_payment_event_list' => :'SellerDealPaymentEventList',
        :'debt_recovery_event_list' => :'DebtRecoveryEventList',
        :'loan_servicing_event_list' => :'LoanServicingEventList',
        :'adjustment_event_list' => :'AdjustmentEventList',
        :'safet_reimbursement_event_list' => :'SAFETReimbursementEventList',
        :'seller_review_enrollment_payment_event_list' => :'SellerReviewEnrollmentPaymentEventList',
        :'fba_liquidation_event_list' => :'FBALiquidationEventList',
        :'coupon_payment_event_list' => :'CouponPaymentEventList',
        :'imaging_services_fee_event_list' => :'ImagingServicesFeeEventList',
        :'network_commingling_transaction_event_list' => :'NetworkComminglingTransactionEventList',
        :'affordability_expense_event_list' => :'AffordabilityExpenseEventList',
        :'affordability_expense_reversal_event_list' => :'AffordabilityExpenseReversalEventList'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'shipment_event_list' => :'Object',
        :'refund_event_list' => :'Object',
        :'guarantee_claim_event_list' => :'Object',
        :'chargeback_event_list' => :'Object',
        :'pay_with_amazon_event_list' => :'Object',
        :'service_provider_credit_event_list' => :'Object',
        :'retrocharge_event_list' => :'Object',
        :'rental_transaction_event_list' => :'Object',
        :'product_ads_payment_event_list' => :'Object',
        :'service_fee_event_list' => :'Object',
        :'seller_deal_payment_event_list' => :'Object',
        :'debt_recovery_event_list' => :'Object',
        :'loan_servicing_event_list' => :'Object',
        :'adjustment_event_list' => :'Object',
        :'safet_reimbursement_event_list' => :'Object',
        :'seller_review_enrollment_payment_event_list' => :'Object',
        :'fba_liquidation_event_list' => :'Object',
        :'coupon_payment_event_list' => :'Object',
        :'imaging_services_fee_event_list' => :'Object',
        :'network_commingling_transaction_event_list' => :'Object',
        :'affordability_expense_event_list' => :'Object',
        :'affordability_expense_reversal_event_list' => :'Object'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end
  
    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `AmzSpApi::FinancesApiModel::FinancialEvents` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `AmzSpApi::FinancesApiModel::FinancialEvents`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'shipment_event_list')
        self.shipment_event_list = attributes[:'shipment_event_list']
      end

      if attributes.key?(:'refund_event_list')
        self.refund_event_list = attributes[:'refund_event_list']
      end

      if attributes.key?(:'guarantee_claim_event_list')
        self.guarantee_claim_event_list = attributes[:'guarantee_claim_event_list']
      end

      if attributes.key?(:'chargeback_event_list')
        self.chargeback_event_list = attributes[:'chargeback_event_list']
      end

      if attributes.key?(:'pay_with_amazon_event_list')
        self.pay_with_amazon_event_list = attributes[:'pay_with_amazon_event_list']
      end

      if attributes.key?(:'service_provider_credit_event_list')
        self.service_provider_credit_event_list = attributes[:'service_provider_credit_event_list']
      end

      if attributes.key?(:'retrocharge_event_list')
        self.retrocharge_event_list = attributes[:'retrocharge_event_list']
      end

      if attributes.key?(:'rental_transaction_event_list')
        self.rental_transaction_event_list = attributes[:'rental_transaction_event_list']
      end

      if attributes.key?(:'product_ads_payment_event_list')
        self.product_ads_payment_event_list = attributes[:'product_ads_payment_event_list']
      end

      if attributes.key?(:'service_fee_event_list')
        self.service_fee_event_list = attributes[:'service_fee_event_list']
      end

      if attributes.key?(:'seller_deal_payment_event_list')
        self.seller_deal_payment_event_list = attributes[:'seller_deal_payment_event_list']
      end

      if attributes.key?(:'debt_recovery_event_list')
        self.debt_recovery_event_list = attributes[:'debt_recovery_event_list']
      end

      if attributes.key?(:'loan_servicing_event_list')
        self.loan_servicing_event_list = attributes[:'loan_servicing_event_list']
      end

      if attributes.key?(:'adjustment_event_list')
        self.adjustment_event_list = attributes[:'adjustment_event_list']
      end

      if attributes.key?(:'safet_reimbursement_event_list')
        self.safet_reimbursement_event_list = attributes[:'safet_reimbursement_event_list']
      end

      if attributes.key?(:'seller_review_enrollment_payment_event_list')
        self.seller_review_enrollment_payment_event_list = attributes[:'seller_review_enrollment_payment_event_list']
      end

      if attributes.key?(:'fba_liquidation_event_list')
        self.fba_liquidation_event_list = attributes[:'fba_liquidation_event_list']
      end

      if attributes.key?(:'coupon_payment_event_list')
        self.coupon_payment_event_list = attributes[:'coupon_payment_event_list']
      end

      if attributes.key?(:'imaging_services_fee_event_list')
        self.imaging_services_fee_event_list = attributes[:'imaging_services_fee_event_list']
      end

      if attributes.key?(:'network_commingling_transaction_event_list')
        self.network_commingling_transaction_event_list = attributes[:'network_commingling_transaction_event_list']
      end

      if attributes.key?(:'affordability_expense_event_list')
        self.affordability_expense_event_list = attributes[:'affordability_expense_event_list']
      end

      if attributes.key?(:'affordability_expense_reversal_event_list')
        self.affordability_expense_reversal_event_list = attributes[:'affordability_expense_reversal_event_list']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          shipment_event_list == o.shipment_event_list &&
          refund_event_list == o.refund_event_list &&
          guarantee_claim_event_list == o.guarantee_claim_event_list &&
          chargeback_event_list == o.chargeback_event_list &&
          pay_with_amazon_event_list == o.pay_with_amazon_event_list &&
          service_provider_credit_event_list == o.service_provider_credit_event_list &&
          retrocharge_event_list == o.retrocharge_event_list &&
          rental_transaction_event_list == o.rental_transaction_event_list &&
          product_ads_payment_event_list == o.product_ads_payment_event_list &&
          service_fee_event_list == o.service_fee_event_list &&
          seller_deal_payment_event_list == o.seller_deal_payment_event_list &&
          debt_recovery_event_list == o.debt_recovery_event_list &&
          loan_servicing_event_list == o.loan_servicing_event_list &&
          adjustment_event_list == o.adjustment_event_list &&
          safet_reimbursement_event_list == o.safet_reimbursement_event_list &&
          seller_review_enrollment_payment_event_list == o.seller_review_enrollment_payment_event_list &&
          fba_liquidation_event_list == o.fba_liquidation_event_list &&
          coupon_payment_event_list == o.coupon_payment_event_list &&
          imaging_services_fee_event_list == o.imaging_services_fee_event_list &&
          network_commingling_transaction_event_list == o.network_commingling_transaction_event_list &&
          affordability_expense_event_list == o.affordability_expense_event_list &&
          affordability_expense_reversal_event_list == o.affordability_expense_reversal_event_list
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [shipment_event_list, refund_event_list, guarantee_claim_event_list, chargeback_event_list, pay_with_amazon_event_list, service_provider_credit_event_list, retrocharge_event_list, rental_transaction_event_list, product_ads_payment_event_list, service_fee_event_list, seller_deal_payment_event_list, debt_recovery_event_list, loan_servicing_event_list, adjustment_event_list, safet_reimbursement_event_list, seller_review_enrollment_payment_event_list, fba_liquidation_event_list, coupon_payment_event_list, imaging_services_fee_event_list, network_commingling_transaction_event_list, affordability_expense_event_list, affordability_expense_reversal_event_list].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        elsif attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        AmzSpApi::FinancesApiModel.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end  end
end
