# fulfillment-outbound-api-model

AmzSpApi::FulfillmentOutboundApiModel - the Ruby gem for the Selling Partner APIs for Fulfillment Outbound

The Selling Partner API for Fulfillment Outbound lets you create applications that help a seller fulfill Multi-Channel Fulfillment orders using their inventory in Amazon's fulfillment network. You can get information on both potential and existing fulfillment orders.

This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 2020-07-01
- Package version: 0.1.0
- Build package: io.swagger.codegen.v3.generators.ruby.RubyClientCodegen
For more information, please visit [https://sellercentral.amazon.com/gp/mws/contactus.html](https://sellercentral.amazon.com/gp/mws/contactus.html)

## Installation

### Build a gem

To build the Ruby code into a gem:

```shell
gem build fulfillment-outbound-api-model.gemspec
```

Then either install the gem locally:

```shell
gem install ./fulfillment-outbound-api-model-0.1.0.gem
```
(for development, run `gem install --dev ./fulfillment-outbound-api-model-0.1.0.gem` to install the development dependencies)

or publish the gem to a gem hosting service, e.g. [RubyGems](https://rubygems.org/).

Finally add this to the Gemfile:

    gem 'fulfillment-outbound-api-model', '~> 0.1.0'

### Install from Git

If the Ruby gem is hosted at a git repository: https://github.com/GIT_USER_ID/GIT_REPO_ID, then add the following in the Gemfile:

    gem 'fulfillment-outbound-api-model', :git => 'https://github.com/GIT_USER_ID/GIT_REPO_ID.git'

### Include the Ruby code directly

Include the Ruby code directly using `-I` as follows:

```shell
ruby -Ilib script.rb
```

## Getting Started

Please follow the [installation](#installation) procedure and then run the following code:
```ruby
# Load the gem
require 'fulfillment-outbound-api-model'

api_instance = AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi.new
seller_fulfillment_order_id = 'seller_fulfillment_order_id_example' # String | The identifier assigned to the item by the seller when the fulfillment order was created.


begin
  result = api_instance.cancel_fulfillment_order(seller_fulfillment_order_id)
  p result
rescue AmzSpApi::FulfillmentOutboundApiModel::ApiError => e
  puts "Exception when calling FbaOutboundApi->cancel_fulfillment_order: #{e}"
end

api_instance = AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi.new
body = AmzSpApi::FulfillmentOutboundApiModel::CreateFulfillmentOrderRequest.new # CreateFulfillmentOrderRequest | 


begin
  result = api_instance.create_fulfillment_order(body)
  p result
rescue AmzSpApi::FulfillmentOutboundApiModel::ApiError => e
  puts "Exception when calling FbaOutboundApi->create_fulfillment_order: #{e}"
end

api_instance = AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi.new
body = AmzSpApi::FulfillmentOutboundApiModel::CreateFulfillmentReturnRequest.new # CreateFulfillmentReturnRequest | 
seller_fulfillment_order_id = 'seller_fulfillment_order_id_example' # String | An identifier assigned by the seller to the fulfillment order at the time it was created. The seller uses their own records to find the correct SellerFulfillmentOrderId value based on the buyer's request to return items.


begin
  result = api_instance.create_fulfillment_return(body, seller_fulfillment_order_id)
  p result
rescue AmzSpApi::FulfillmentOutboundApiModel::ApiError => e
  puts "Exception when calling FbaOutboundApi->create_fulfillment_return: #{e}"
end

api_instance = AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi.new
marketplace_id = 'marketplace_id_example' # String | The marketplace for which to return a list of the inventory that is eligible for the specified feature.
feature_name = 'feature_name_example' # String | The name of the feature for which to return a list of eligible inventory.
opts = { 
  next_token: 'next_token_example' # String | A string token returned in the response to your previous request that is used to return the next response page. A value of null will return the first page.
}

begin
  result = api_instance.get_feature_inventory(marketplace_id, feature_name, opts)
  p result
rescue AmzSpApi::FulfillmentOutboundApiModel::ApiError => e
  puts "Exception when calling FbaOutboundApi->get_feature_inventory: #{e}"
end

api_instance = AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi.new
marketplace_id = 'marketplace_id_example' # String | The marketplace for which to return the count.
feature_name = 'feature_name_example' # String | The name of the feature.
seller_sku = 'seller_sku_example' # String | Used to identify an item in the given marketplace. SellerSKU is qualified by the seller's SellerId, which is included with every operation that you submit.


begin
  result = api_instance.get_feature_sku(marketplace_id, feature_name, seller_sku)
  p result
rescue AmzSpApi::FulfillmentOutboundApiModel::ApiError => e
  puts "Exception when calling FbaOutboundApi->get_feature_sku: #{e}"
end

api_instance = AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi.new
marketplace_id = 'marketplace_id_example' # String | The marketplace for which to return the list of features.


begin
  result = api_instance.get_features(marketplace_id)
  p result
rescue AmzSpApi::FulfillmentOutboundApiModel::ApiError => e
  puts "Exception when calling FbaOutboundApi->get_features: #{e}"
end

api_instance = AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi.new
seller_fulfillment_order_id = 'seller_fulfillment_order_id_example' # String | The identifier assigned to the item by the seller when the fulfillment order was created.


begin
  result = api_instance.get_fulfillment_order(seller_fulfillment_order_id)
  p result
rescue AmzSpApi::FulfillmentOutboundApiModel::ApiError => e
  puts "Exception when calling FbaOutboundApi->get_fulfillment_order: #{e}"
end

api_instance = AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi.new
body = AmzSpApi::FulfillmentOutboundApiModel::GetFulfillmentPreviewRequest.new # GetFulfillmentPreviewRequest | 


begin
  result = api_instance.get_fulfillment_preview(body)
  p result
rescue AmzSpApi::FulfillmentOutboundApiModel::ApiError => e
  puts "Exception when calling FbaOutboundApi->get_fulfillment_preview: #{e}"
end

api_instance = AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi.new
package_number = 56 # Integer | The unencrypted package identifier returned by the getFulfillmentOrder operation.


begin
  result = api_instance.get_package_tracking_details(package_number)
  p result
rescue AmzSpApi::FulfillmentOutboundApiModel::ApiError => e
  puts "Exception when calling FbaOutboundApi->get_package_tracking_details: #{e}"
end

api_instance = AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi.new
opts = { 
  query_start_date: DateTime.parse('2013-10-20T19:20:30+01:00'), # DateTime | A date used to select fulfillment orders that were last updated after (or at) a specified time. An update is defined as any change in fulfillment order status, including the creation of a new fulfillment order.
  next_token: 'next_token_example' # String | A string token returned in the response to your previous request.
}

begin
  result = api_instance.list_all_fulfillment_orders(opts)
  p result
rescue AmzSpApi::FulfillmentOutboundApiModel::ApiError => e
  puts "Exception when calling FbaOutboundApi->list_all_fulfillment_orders: #{e}"
end

api_instance = AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi.new
seller_sku = 'seller_sku_example' # String | The seller SKU for which return reason codes are required.
language = 'language_example' # String | The language that the TranslatedDescription property of the ReasonCodeDetails response object should be translated into.
opts = { 
  marketplace_id: 'marketplace_id_example', # String | The marketplace for which the seller wants return reason codes.
  seller_fulfillment_order_id: 'seller_fulfillment_order_id_example' # String | The identifier assigned to the item by the seller when the fulfillment order was created. The service uses this value to determine the marketplace for which the seller wants return reason codes.
}

begin
  result = api_instance.list_return_reason_codes(seller_sku, language, opts)
  p result
rescue AmzSpApi::FulfillmentOutboundApiModel::ApiError => e
  puts "Exception when calling FbaOutboundApi->list_return_reason_codes: #{e}"
end

api_instance = AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi.new
body = AmzSpApi::FulfillmentOutboundApiModel::UpdateFulfillmentOrderRequest.new # UpdateFulfillmentOrderRequest | 
seller_fulfillment_order_id = 'seller_fulfillment_order_id_example' # String | The identifier assigned to the item by the seller when the fulfillment order was created.


begin
  result = api_instance.update_fulfillment_order(body, seller_fulfillment_order_id)
  p result
rescue AmzSpApi::FulfillmentOutboundApiModel::ApiError => e
  puts "Exception when calling FbaOutboundApi->update_fulfillment_order: #{e}"
end
```

## Documentation for API Endpoints

All URIs are relative to *https://sellingpartnerapi-na.amazon.com/*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi* | [**cancel_fulfillment_order**](docs/FbaOutboundApi.md#cancel_fulfillment_order) | **PUT** /fba/outbound/2020-07-01/fulfillmentOrders/{sellerFulfillmentOrderId}/cancel | 
*AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi* | [**create_fulfillment_order**](docs/FbaOutboundApi.md#create_fulfillment_order) | **POST** /fba/outbound/2020-07-01/fulfillmentOrders | 
*AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi* | [**create_fulfillment_return**](docs/FbaOutboundApi.md#create_fulfillment_return) | **PUT** /fba/outbound/2020-07-01/fulfillmentOrders/{sellerFulfillmentOrderId}/return | 
*AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi* | [**get_feature_inventory**](docs/FbaOutboundApi.md#get_feature_inventory) | **GET** /fba/outbound/2020-07-01/features/inventory/{featureName} | 
*AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi* | [**get_feature_sku**](docs/FbaOutboundApi.md#get_feature_sku) | **GET** /fba/outbound/2020-07-01/features/inventory/{featureName}/{sellerSku} | 
*AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi* | [**get_features**](docs/FbaOutboundApi.md#get_features) | **GET** /fba/outbound/2020-07-01/features | 
*AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi* | [**get_fulfillment_order**](docs/FbaOutboundApi.md#get_fulfillment_order) | **GET** /fba/outbound/2020-07-01/fulfillmentOrders/{sellerFulfillmentOrderId} | 
*AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi* | [**get_fulfillment_preview**](docs/FbaOutboundApi.md#get_fulfillment_preview) | **POST** /fba/outbound/2020-07-01/fulfillmentOrders/preview | 
*AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi* | [**get_package_tracking_details**](docs/FbaOutboundApi.md#get_package_tracking_details) | **GET** /fba/outbound/2020-07-01/tracking | 
*AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi* | [**list_all_fulfillment_orders**](docs/FbaOutboundApi.md#list_all_fulfillment_orders) | **GET** /fba/outbound/2020-07-01/fulfillmentOrders | 
*AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi* | [**list_return_reason_codes**](docs/FbaOutboundApi.md#list_return_reason_codes) | **GET** /fba/outbound/2020-07-01/returnReasonCodes | 
*AmzSpApi::FulfillmentOutboundApiModel::FbaOutboundApi* | [**update_fulfillment_order**](docs/FbaOutboundApi.md#update_fulfillment_order) | **PUT** /fba/outbound/2020-07-01/fulfillmentOrders/{sellerFulfillmentOrderId} | 

## Documentation for Models

 - [AmzSpApi::FulfillmentOutboundApiModel::AdditionalLocationInfo](docs/AdditionalLocationInfo.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::Address](docs/Address.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::CODSettings](docs/CODSettings.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::CancelFulfillmentOrderResponse](docs/CancelFulfillmentOrderResponse.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::CreateFulfillmentOrderItem](docs/CreateFulfillmentOrderItem.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::CreateFulfillmentOrderItemList](docs/CreateFulfillmentOrderItemList.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::CreateFulfillmentOrderRequest](docs/CreateFulfillmentOrderRequest.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::CreateFulfillmentOrderResponse](docs/CreateFulfillmentOrderResponse.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::CreateFulfillmentReturnRequest](docs/CreateFulfillmentReturnRequest.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::CreateFulfillmentReturnResponse](docs/CreateFulfillmentReturnResponse.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::CreateFulfillmentReturnResult](docs/CreateFulfillmentReturnResult.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::CreateReturnItem](docs/CreateReturnItem.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::CreateReturnItemList](docs/CreateReturnItemList.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::CurrentStatus](docs/CurrentStatus.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::Decimal](docs/Decimal.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::DeliveryWindow](docs/DeliveryWindow.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::DeliveryWindowList](docs/DeliveryWindowList.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::Error](docs/Error.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::ErrorList](docs/ErrorList.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::EventCode](docs/EventCode.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::Feature](docs/Feature.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::FeatureSettings](docs/FeatureSettings.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::FeatureSku](docs/FeatureSku.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::Features](docs/Features.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::Fee](docs/Fee.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::FeeList](docs/FeeList.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::FulfillmentAction](docs/FulfillmentAction.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::FulfillmentOrder](docs/FulfillmentOrder.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::FulfillmentOrderItem](docs/FulfillmentOrderItem.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::FulfillmentOrderItemList](docs/FulfillmentOrderItemList.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::FulfillmentOrderStatus](docs/FulfillmentOrderStatus.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::FulfillmentPolicy](docs/FulfillmentPolicy.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::FulfillmentPreview](docs/FulfillmentPreview.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::FulfillmentPreviewItem](docs/FulfillmentPreviewItem.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::FulfillmentPreviewItemList](docs/FulfillmentPreviewItemList.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::FulfillmentPreviewList](docs/FulfillmentPreviewList.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::FulfillmentPreviewShipment](docs/FulfillmentPreviewShipment.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::FulfillmentPreviewShipmentList](docs/FulfillmentPreviewShipmentList.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::FulfillmentReturnItemStatus](docs/FulfillmentReturnItemStatus.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::FulfillmentShipment](docs/FulfillmentShipment.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::FulfillmentShipmentItem](docs/FulfillmentShipmentItem.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::FulfillmentShipmentItemList](docs/FulfillmentShipmentItemList.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::FulfillmentShipmentList](docs/FulfillmentShipmentList.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::FulfillmentShipmentPackage](docs/FulfillmentShipmentPackage.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::FulfillmentShipmentPackageList](docs/FulfillmentShipmentPackageList.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::GetFeatureInventoryResponse](docs/GetFeatureInventoryResponse.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::GetFeatureInventoryResult](docs/GetFeatureInventoryResult.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::GetFeatureSkuResponse](docs/GetFeatureSkuResponse.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::GetFeatureSkuResult](docs/GetFeatureSkuResult.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::GetFeaturesResponse](docs/GetFeaturesResponse.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::GetFeaturesResult](docs/GetFeaturesResult.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::GetFulfillmentOrderResponse](docs/GetFulfillmentOrderResponse.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::GetFulfillmentOrderResult](docs/GetFulfillmentOrderResult.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::GetFulfillmentPreviewItem](docs/GetFulfillmentPreviewItem.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::GetFulfillmentPreviewItemList](docs/GetFulfillmentPreviewItemList.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::GetFulfillmentPreviewRequest](docs/GetFulfillmentPreviewRequest.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::GetFulfillmentPreviewResponse](docs/GetFulfillmentPreviewResponse.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::GetFulfillmentPreviewResult](docs/GetFulfillmentPreviewResult.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::GetPackageTrackingDetailsResponse](docs/GetPackageTrackingDetailsResponse.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::InvalidItemReason](docs/InvalidItemReason.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::InvalidItemReasonCode](docs/InvalidItemReasonCode.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::InvalidReturnItem](docs/InvalidReturnItem.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::InvalidReturnItemList](docs/InvalidReturnItemList.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::ListAllFulfillmentOrdersResponse](docs/ListAllFulfillmentOrdersResponse.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::ListAllFulfillmentOrdersResult](docs/ListAllFulfillmentOrdersResult.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::ListReturnReasonCodesResponse](docs/ListReturnReasonCodesResponse.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::ListReturnReasonCodesResult](docs/ListReturnReasonCodesResult.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::Money](docs/Money.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::NotificationEmailList](docs/NotificationEmailList.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::PackageTrackingDetails](docs/PackageTrackingDetails.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::Quantity](docs/Quantity.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::ReasonCodeDetails](docs/ReasonCodeDetails.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::ReasonCodeDetailsList](docs/ReasonCodeDetailsList.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::ReturnAuthorization](docs/ReturnAuthorization.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::ReturnAuthorizationList](docs/ReturnAuthorizationList.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::ReturnItem](docs/ReturnItem.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::ReturnItemDisposition](docs/ReturnItemDisposition.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::ReturnItemList](docs/ReturnItemList.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::ScheduledDeliveryInfo](docs/ScheduledDeliveryInfo.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::ShippingSpeedCategory](docs/ShippingSpeedCategory.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::ShippingSpeedCategoryList](docs/ShippingSpeedCategoryList.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::StringList](docs/StringList.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::Timestamp](docs/Timestamp.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::TrackingAddress](docs/TrackingAddress.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::TrackingEvent](docs/TrackingEvent.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::TrackingEventList](docs/TrackingEventList.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::UnfulfillablePreviewItem](docs/UnfulfillablePreviewItem.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::UnfulfillablePreviewItemList](docs/UnfulfillablePreviewItemList.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::UpdateFulfillmentOrderItem](docs/UpdateFulfillmentOrderItem.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::UpdateFulfillmentOrderItemList](docs/UpdateFulfillmentOrderItemList.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::UpdateFulfillmentOrderRequest](docs/UpdateFulfillmentOrderRequest.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::UpdateFulfillmentOrderResponse](docs/UpdateFulfillmentOrderResponse.md)
 - [AmzSpApi::FulfillmentOutboundApiModel::Weight](docs/Weight.md)

## Documentation for Authorization

 All endpoints do not require authorization.

