# merchant-fulfillment-api-model

AmzSpApi::MerchantFulfillmentApiModel - the Ruby gem for the Selling Partner API for Merchant Fulfillment

The Selling Partner API for Merchant Fulfillment helps you build applications that let sellers purchase shipping for non-Prime and Prime orders using Amazon’s Buy Shipping Services.

This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: v0
- Package version: 0.1.0
- Build package: io.swagger.codegen.v3.generators.ruby.RubyClientCodegen
For more information, please visit [https://sellercentral.amazon.com/gp/mws/contactus.html](https://sellercentral.amazon.com/gp/mws/contactus.html)

## Installation

### Build a gem

To build the Ruby code into a gem:

```shell
gem build merchant-fulfillment-api-model.gemspec
```

Then either install the gem locally:

```shell
gem install ./merchant-fulfillment-api-model-0.1.0.gem
```
(for development, run `gem install --dev ./merchant-fulfillment-api-model-0.1.0.gem` to install the development dependencies)

or publish the gem to a gem hosting service, e.g. [RubyGems](https://rubygems.org/).

Finally add this to the Gemfile:

    gem 'merchant-fulfillment-api-model', '~> 0.1.0'

### Install from Git

If the Ruby gem is hosted at a git repository: https://github.com/GIT_USER_ID/GIT_REPO_ID, then add the following in the Gemfile:

    gem 'merchant-fulfillment-api-model', :git => 'https://github.com/GIT_USER_ID/GIT_REPO_ID.git'

### Include the Ruby code directly

Include the Ruby code directly using `-I` as follows:

```shell
ruby -Ilib script.rb
```

## Getting Started

Please follow the [installation](#installation) procedure and then run the following code:
```ruby
# Load the gem
require 'merchant-fulfillment-api-model'

api_instance = AmzSpApi::MerchantFulfillmentApiModel::MerchantFulfillmentApi.new
shipment_id = 'shipment_id_example' # String | The Amazon-defined shipment identifier for the shipment to cancel.


begin
  result = api_instance.cancel_shipment(shipment_id)
  p result
rescue AmzSpApi::MerchantFulfillmentApiModel::ApiError => e
  puts "Exception when calling MerchantFulfillmentApi->cancel_shipment: #{e}"
end

api_instance = AmzSpApi::MerchantFulfillmentApiModel::MerchantFulfillmentApi.new
shipment_id = 'shipment_id_example' # String | The Amazon-defined shipment identifier for the shipment to cancel.


begin
  result = api_instance.cancel_shipment_old(shipment_id)
  p result
rescue AmzSpApi::MerchantFulfillmentApiModel::ApiError => e
  puts "Exception when calling MerchantFulfillmentApi->cancel_shipment_old: #{e}"
end

api_instance = AmzSpApi::MerchantFulfillmentApiModel::MerchantFulfillmentApi.new
body = AmzSpApi::MerchantFulfillmentApiModel::CreateShipmentRequest.new # CreateShipmentRequest | 


begin
  result = api_instance.create_shipment(body)
  p result
rescue AmzSpApi::MerchantFulfillmentApiModel::ApiError => e
  puts "Exception when calling MerchantFulfillmentApi->create_shipment: #{e}"
end

api_instance = AmzSpApi::MerchantFulfillmentApiModel::MerchantFulfillmentApi.new
body = AmzSpApi::MerchantFulfillmentApiModel::GetAdditionalSellerInputsRequest.new # GetAdditionalSellerInputsRequest | 


begin
  result = api_instance.get_additional_seller_inputs(body)
  p result
rescue AmzSpApi::MerchantFulfillmentApiModel::ApiError => e
  puts "Exception when calling MerchantFulfillmentApi->get_additional_seller_inputs: #{e}"
end

api_instance = AmzSpApi::MerchantFulfillmentApiModel::MerchantFulfillmentApi.new
body = AmzSpApi::MerchantFulfillmentApiModel::GetAdditionalSellerInputsRequest.new # GetAdditionalSellerInputsRequest | 


begin
  result = api_instance.get_additional_seller_inputs_old(body)
  p result
rescue AmzSpApi::MerchantFulfillmentApiModel::ApiError => e
  puts "Exception when calling MerchantFulfillmentApi->get_additional_seller_inputs_old: #{e}"
end

api_instance = AmzSpApi::MerchantFulfillmentApiModel::MerchantFulfillmentApi.new
body = AmzSpApi::MerchantFulfillmentApiModel::GetEligibleShipmentServicesRequest.new # GetEligibleShipmentServicesRequest | 


begin
  result = api_instance.get_eligible_shipment_services(body)
  p result
rescue AmzSpApi::MerchantFulfillmentApiModel::ApiError => e
  puts "Exception when calling MerchantFulfillmentApi->get_eligible_shipment_services: #{e}"
end

api_instance = AmzSpApi::MerchantFulfillmentApiModel::MerchantFulfillmentApi.new
body = AmzSpApi::MerchantFulfillmentApiModel::GetEligibleShipmentServicesRequest.new # GetEligibleShipmentServicesRequest | 


begin
  result = api_instance.get_eligible_shipment_services_old(body)
  p result
rescue AmzSpApi::MerchantFulfillmentApiModel::ApiError => e
  puts "Exception when calling MerchantFulfillmentApi->get_eligible_shipment_services_old: #{e}"
end

api_instance = AmzSpApi::MerchantFulfillmentApiModel::MerchantFulfillmentApi.new
shipment_id = 'shipment_id_example' # String | The Amazon-defined shipment identifier for the shipment.


begin
  result = api_instance.get_shipment(shipment_id)
  p result
rescue AmzSpApi::MerchantFulfillmentApiModel::ApiError => e
  puts "Exception when calling MerchantFulfillmentApi->get_shipment: #{e}"
end
```

## Documentation for API Endpoints

All URIs are relative to *https://sellingpartnerapi-na.amazon.com/*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AmzSpApi::MerchantFulfillmentApiModel::MerchantFulfillmentApi* | [**cancel_shipment**](docs/MerchantFulfillmentApi.md#cancel_shipment) | **DELETE** /mfn/v0/shipments/{shipmentId} | 
*AmzSpApi::MerchantFulfillmentApiModel::MerchantFulfillmentApi* | [**cancel_shipment_old**](docs/MerchantFulfillmentApi.md#cancel_shipment_old) | **PUT** /mfn/v0/shipments/{shipmentId}/cancel | 
*AmzSpApi::MerchantFulfillmentApiModel::MerchantFulfillmentApi* | [**create_shipment**](docs/MerchantFulfillmentApi.md#create_shipment) | **POST** /mfn/v0/shipments | 
*AmzSpApi::MerchantFulfillmentApiModel::MerchantFulfillmentApi* | [**get_additional_seller_inputs**](docs/MerchantFulfillmentApi.md#get_additional_seller_inputs) | **POST** /mfn/v0/additionalSellerInputs | 
*AmzSpApi::MerchantFulfillmentApiModel::MerchantFulfillmentApi* | [**get_additional_seller_inputs_old**](docs/MerchantFulfillmentApi.md#get_additional_seller_inputs_old) | **POST** /mfn/v0/sellerInputs | 
*AmzSpApi::MerchantFulfillmentApiModel::MerchantFulfillmentApi* | [**get_eligible_shipment_services**](docs/MerchantFulfillmentApi.md#get_eligible_shipment_services) | **POST** /mfn/v0/eligibleShippingServices | 
*AmzSpApi::MerchantFulfillmentApiModel::MerchantFulfillmentApi* | [**get_eligible_shipment_services_old**](docs/MerchantFulfillmentApi.md#get_eligible_shipment_services_old) | **POST** /mfn/v0/eligibleServices | 
*AmzSpApi::MerchantFulfillmentApiModel::MerchantFulfillmentApi* | [**get_shipment**](docs/MerchantFulfillmentApi.md#get_shipment) | **GET** /mfn/v0/shipments/{shipmentId} | 

## Documentation for Models

 - [AmzSpApi::MerchantFulfillmentApiModel::AdditionalInputs](docs/AdditionalInputs.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::AdditionalInputsList](docs/AdditionalInputsList.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::AdditionalSellerInput](docs/AdditionalSellerInput.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::AdditionalSellerInputs](docs/AdditionalSellerInputs.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::AdditionalSellerInputsList](docs/AdditionalSellerInputsList.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::Address](docs/Address.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::AddressLine1](docs/AddressLine1.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::AddressLine2](docs/AddressLine2.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::AddressLine3](docs/AddressLine3.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::AddressName](docs/AddressName.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::AmazonOrderId](docs/AmazonOrderId.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::AvailableCarrierWillPickUpOption](docs/AvailableCarrierWillPickUpOption.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::AvailableCarrierWillPickUpOptionsList](docs/AvailableCarrierWillPickUpOptionsList.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::AvailableDeliveryExperienceOption](docs/AvailableDeliveryExperienceOption.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::AvailableDeliveryExperienceOptionsList](docs/AvailableDeliveryExperienceOptionsList.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::AvailableFormatOptionsForLabel](docs/AvailableFormatOptionsForLabel.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::AvailableFormatOptionsForLabelList](docs/AvailableFormatOptionsForLabelList.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::AvailableShippingServiceOptions](docs/AvailableShippingServiceOptions.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::CancelShipmentResponse](docs/CancelShipmentResponse.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::CarrierWillPickUpOption](docs/CarrierWillPickUpOption.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::City](docs/City.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::Constraint](docs/Constraint.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::Constraints](docs/Constraints.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::CountryCode](docs/CountryCode.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::CreateShipmentRequest](docs/CreateShipmentRequest.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::CreateShipmentResponse](docs/CreateShipmentResponse.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::CurrencyAmount](docs/CurrencyAmount.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::CustomTextForLabel](docs/CustomTextForLabel.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::DeliveryExperienceOption](docs/DeliveryExperienceOption.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::DeliveryExperienceType](docs/DeliveryExperienceType.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::DistrictOrCounty](docs/DistrictOrCounty.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::EmailAddress](docs/EmailAddress.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::Error](docs/Error.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::ErrorList](docs/ErrorList.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::FileContents](docs/FileContents.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::FileType](docs/FileType.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::GetAdditionalSellerInputsRequest](docs/GetAdditionalSellerInputsRequest.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::GetAdditionalSellerInputsResponse](docs/GetAdditionalSellerInputsResponse.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::GetAdditionalSellerInputsResult](docs/GetAdditionalSellerInputsResult.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::GetEligibleShipmentServicesRequest](docs/GetEligibleShipmentServicesRequest.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::GetEligibleShipmentServicesResponse](docs/GetEligibleShipmentServicesResponse.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::GetEligibleShipmentServicesResult](docs/GetEligibleShipmentServicesResult.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::GetShipmentResponse](docs/GetShipmentResponse.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::HazmatType](docs/HazmatType.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::InputTargetType](docs/InputTargetType.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::Item](docs/Item.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::ItemDescription](docs/ItemDescription.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::ItemLevelFields](docs/ItemLevelFields.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::ItemLevelFieldsList](docs/ItemLevelFieldsList.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::ItemList](docs/ItemList.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::ItemQuantity](docs/ItemQuantity.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::Label](docs/Label.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::LabelCustomization](docs/LabelCustomization.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::LabelDimension](docs/LabelDimension.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::LabelDimensions](docs/LabelDimensions.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::LabelFormat](docs/LabelFormat.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::LabelFormatList](docs/LabelFormatList.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::LabelFormatOption](docs/LabelFormatOption.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::LabelFormatOptionRequest](docs/LabelFormatOptionRequest.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::Length](docs/Length.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::OrderItemId](docs/OrderItemId.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::PackageDimension](docs/PackageDimension.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::PackageDimensions](docs/PackageDimensions.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::PhoneNumber](docs/PhoneNumber.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::PostalCode](docs/PostalCode.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::PredefinedPackageDimensions](docs/PredefinedPackageDimensions.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::RejectedShippingService](docs/RejectedShippingService.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::RejectedShippingServiceList](docs/RejectedShippingServiceList.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::RestrictedSetValues](docs/RestrictedSetValues.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::SellerInputDefinition](docs/SellerInputDefinition.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::SellerOrderId](docs/SellerOrderId.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::Shipment](docs/Shipment.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::ShipmentId](docs/ShipmentId.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::ShipmentRequestDetails](docs/ShipmentRequestDetails.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::ShipmentStatus](docs/ShipmentStatus.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::ShippingOfferingFilter](docs/ShippingOfferingFilter.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::ShippingService](docs/ShippingService.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::ShippingServiceIdentifier](docs/ShippingServiceIdentifier.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::ShippingServiceList](docs/ShippingServiceList.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::ShippingServiceOptions](docs/ShippingServiceOptions.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::StandardIdForLabel](docs/StandardIdForLabel.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::StateOrProvinceCode](docs/StateOrProvinceCode.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::TemporarilyUnavailableCarrier](docs/TemporarilyUnavailableCarrier.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::TemporarilyUnavailableCarrierList](docs/TemporarilyUnavailableCarrierList.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::TermsAndConditionsNotAcceptedCarrier](docs/TermsAndConditionsNotAcceptedCarrier.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::TermsAndConditionsNotAcceptedCarrierList](docs/TermsAndConditionsNotAcceptedCarrierList.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::Timestamp](docs/Timestamp.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::TrackingId](docs/TrackingId.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::TransparencyCode](docs/TransparencyCode.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::TransparencyCodeList](docs/TransparencyCodeList.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::UnitOfLength](docs/UnitOfLength.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::UnitOfWeight](docs/UnitOfWeight.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::Weight](docs/Weight.md)
 - [AmzSpApi::MerchantFulfillmentApiModel::WeightValue](docs/WeightValue.md)

## Documentation for Authorization

 All endpoints do not require authorization.

